﻿<?php

if (!defined('IN_ECS'))
{
    die('Hacking attempt');
}

$shipping_lang = ROOT_PATH.'languages/' .$GLOBALS['_CFG']['lang']. '/shipping/smilepay_b2cp.php';
if (file_exists($shipping_lang))
{
    global $_LANG;
    include_once($shipping_lang);
}

/* 模块的基本信息 */
if (isset($set_modules) && $set_modules == TRUE)
{
    $i = (isset($modules)) ? count($modules) : 0;

    /* 配送方式插件的代码必须和文件名保持一致 */
    $modules[$i]['code']    = basename(__FILE__, '.php');

    $modules[$i]['version'] = '2.3.0';

    /* 配送方式的描述 */
    $modules[$i]['desc']    = 'smilepay_b2cp_desc';

    /* 配送方式是否支持货到付款 */
    $modules[$i]['cod']     = true;

    /* 插件的作者 */
    $modules[$i]['author']  = '訊航科技';

    /* 插件作者的官方网站 */
    $modules[$i]['website'] = 'http://www.smilepay.net/';

    /* 配送接口需要的参数 */
    $modules[$i]['configure'] = array(
                                    array('name' => 'base_fee', 'value' => 0),
                                );

    /* 模式编辑器 */
    $modules[$i]['print_model'] = 2;

    /* 打印单背景 */
    $modules[$i]['print_bg'] = '';

   /* 打印快递单标签位置信息 */
    $modules[$i]['config_lable'] = '';

    return;
}

class smilepay_b2cp
{
    /*------------------------------------------------------ */
    //-- PUBLIC ATTRIBUTEs
    /*------------------------------------------------------ */

    /**
     * 配置信息
     */
    var $configure;
    protected $b2c_code = 'b2cp';
    /*------------------------------------------------------ */
    //-- PUBLIC METHODs
    /*------------------------------------------------------ */

    /**
     * 构造函数
     *
     * @param: $configure[array]    配送方式的参数的数组
     *
     * @return null
     */
    function smilepay_b2cp($cfg = array())
    {
        foreach ($cfg AS $key => $val)
        {
            $this->configure[$val['name']] = $val['value'];
        }
    }

    /**
     * 计算订单的配送费用的函数
     *
     * @param   float   $goods_weight   商品重量
     * @param   float   $goods_amount   商品金额
     * @return  decimal
     */
    function calculate($goods_weight, $goods_amount)
    {
        if ($this->configure['free_money'] > 0 && $goods_amount >= $this->configure['free_money'])
        {
            return 0;
        }
        else
        {
            return isset($this->configure['base_fee']) ? $this->configure['base_fee'] : 0;
        }
    }

    /**
     * 查询发货状态
     * 该配送方式不支持查询发货状态
     *
     * @access  public
     * @param   string  $invoice_sn     发货单号
     * @return  string
     */
    function query($invoice_sn)
    {
        return $invoice_sn;
    }

    function validateparam()
    {
        $result = array();
        
        if(mb_strlen($_SESSION['flow_order']['consignee'],'utf-8')>5)
           $result['error']=$GLOBALS['_LANG']['smilepay_b2cp_error_name']; 
        elseif (!preg_match("/^[0][9][0-9]{8,8}$/",$_SESSION['flow_order']['mobile']))  // phone rule
           $result['error']=$GLOBALS['_LANG']['smilepay_b2cp_error_phone']; 

        return $result;
    }
    function get_emap_url()
    {
        $url= $GLOBALS['ecs']->url()."smilepay_b2c_recv.php";
        $params="action=emapreturn|type=$this->b2c_code";
        return "https://emap.presco.com.tw/emapu8.ashx?eshopid=870&servicetype=1&tempvar=$params&url=$url";
    }
 
    function set_emap_data($data)
    {
       $_SESSION['smilepay_b2cup_data']['address'] = $data['address'];
       $_SESSION['smilepay_b2cup_data']['storeid'] = $data['storeid'];
       $_SESSION['smilepay_b2cup_data']['storename'] = $data['storename'];
       $_SESSION['smilepay_b2cup_data']['type'] = $data['type'];
    }
    function get_storename()
    {
       return isset($_SESSION['smilepay_b2cup_data']['storename']) ? $_SESSION['smilepay_b2cup_data']['storename'] : false;
    }
    function get_storedata()
    {
       if(!isset($_SESSION['smilepay_b2cup_data']['type']) || $_SESSION['smilepay_b2cup_data']['type']!=$this->b2c_code) //type_error
       {
           return false;
       }
       $result = array(
                    'storeaddress' =>  $_SESSION['smilepay_b2cup_data']['address'],
                    'storeid' => $_SESSION['smilepay_b2cup_data']['storeid'] ,
                    'storename' => $_SESSION['smilepay_b2cup_data']['storename'],
                    );
       return  $result;
    }
    function is_emap_selected()
    {
       if(!isset($_SESSION['smilepay_b2cup_data']['type']) || $_SESSION['smilepay_b2cup_data']['type']!=$this->b2c_code) //type_error
       {
           return false;
       }

       if(!isset(  $_SESSION['smilepay_b2cup_data']['address']) || !isset($_SESSION['smilepay_b2cup_data']['storeid']) || !isset( $_SESSION['smilepay_b2cup_data']['storename'])
            || empty(  $_SESSION['smilepay_b2cup_data']['address']) || empty($_SESSION['smilepay_b2cup_data']['storeid']) || empty( $_SESSION['smilepay_b2cup_data']['storename']))
       {
            return false;
       }
       return true;
    }
    function getConfigCode()
    {
        return $this->b2c_code;
    }
    public function cleardata()
    {
        unset( $_SESSION['smilepay_b2cup_data']);
    }
}
?>

