<?php   
define('IN_ECS', true);
/* 支付方式代碼 */

require(dirname(__FILE__) . '/includes/init.php');
require(ROOT_PATH . 'includes/lib_payment.php');
require(ROOT_PATH . 'includes/lib_order.php');

$pay_code = !empty($_REQUEST['code']) ? trim($_REQUEST['code']) : ''; 

/* 參數是否為空 */

if (empty($pay_code))
{
    $msg = $_LANG['pay_not_exist'];
}
else                                                                 
{
        /* 檢查code裡面有沒有問號 */
    if (strpos($pay_code, '?') !== false)
    {
        $arr1 = explode('?', $pay_code);
        $arr2 = explode('=', $arr1[1]);

        $_REQUEST['code']   = $arr1[0];
        $_REQUEST[$arr2[0]] = $arr2[1];
        $_GET['code']       = $arr1[0];
        $_GET[$arr2[0]]     = $arr2[1];
        $pay_code           = $arr1[0];
    }
    
    $sql = "SELECT COUNT(*) FROM " . $ecs->table('payment') . " WHERE pay_code = '$pay_code' AND enabled = 1";
    if ($db->getOne($sql) == 0)
    {
        $msg = $_LANG['pay_disabled'];
    }
    else
    {     
        $plugin_file = 'includes/modules/payment/' . $pay_code . '.php';

        /* 檢查插件文件是否存在，如果存在則驗證支付是否成功，否則則返回失敗信息 */
        if (file_exists($plugin_file))
        {
            /* 根據支付方式代碼創建支付類的對象並調用其響應操作方法 */
            include_once($plugin_file);

          // 接收
            $od_sob           = $_REQUEST['Od_sob'];
            $data_id          = $_REQUEST['Data_id'];
            $amount           = trim($_REQUEST['Amount']);
            
            //ATM CODE
            $Remittance_bank  = $_REQUEST['Remittance_bank'];
            $Remittance_no    = $_REQUEST['Remittance_no'];
            $Remittance_name  = $_REQUEST['Remittance_name'];
            $Remittance       = $_REQUEST['Remittance'];
      
            //cvs CODE
            $Payment1       = $_REQUEST['Payment1'];
            $Payment2       = $_REQUEST['Payment2'];
            $Payment3       = $_REQUEST['Payment3'];
            //IBON CODE
            $ibon           = $_REQUEST['ibon'];
            //FAMI CODE
            $fami           = $_REQUEST['Famiport'];
            
            $passcode_in       = $_REQUEST['Remark'];
            $Deadline_date     = $_REQUEST['Deadline_date'];
            $Deadline_time     = $_REQUEST['Deadline_time'];
            $smseid            = trim($_REQUEST['Smseid']);
            $mid_smilepay      = $_REQUEST['Mid_smilepay'];    

            //payment mode load 各項參數
         
            switch ($pay_code){
            case 'smilepayatm' :
                  $payment = new $pay_code();            
                  ($payment->customer_bill()) ? $msg= sprintf($_LANG['smilepayatm_custom_bill_template'],$data_id,urldecode($Remittance_bank),$Remittance_no,urldecode($Remittance_name),$Remittance,$amount): $msg = $_LANG['pay_fail'];
                  
            break;               
            
            case 'smilepaycvs' :      
                  $payment = new $pay_code();
                  if($payment->customer_bill()) {
                   $msg = sprintf($_LANG['smilepaycvs_custom_bill_template1'],$_CFG['shop_title'],urldecode($od_sob),$Payment2,$amount,$data_id,$GLOBALS['ecs']->url(),$_CFG['service_phone']);
                   $msg.= sprintf($_LANG['smilepaycvs_custom_bill_template2'],urldecode($od_sob),$Payment2,$amount,$data_id,$GLOBALS['ecs']->url(),$_CFG['service_phone']);             
                   $msg.= sprintf($_LANG['smilepaycvs_custom_bill_template3'],$Payment1,$Payment2,$Payment3,$Deadline_date,$Deadline_time);
                  }
                  else{
                    $msg = $_LANG['pay_fail'];
                  }
 
            break;
            
            case 'smilepayibon' :

                  //get ibon status
                  switch ($ibon){
                  case 'ibon_timeout':
                   $ibon = $_LANG['smilepayibon_custom_bill_ibon_error'];
                  break;
                  case 'ibon_err01':
                   $ibon = $_LANG['smilepayibon_custom_bill_ibon_error'];
                  break;
                  case 'ibon_err02':
                   $ibon = $_LANG['smilepayibon_custom_bill_ibon_error'];
                  break;
                  case 'ibon_err03':
                   $ibon = $_LANG['smilepayibon_custom_bill_ibon_error'];
                  break;
                  case 'ibon_err04':
                   $ibon = $_LANG['smilepayibon_custom_bill_ibon_error'];
                  break;
                  default:
                    $ibon = $ibon;                        
                  }
                  $payment = new $pay_code();
                  ($payment->customer_bill()) ? $msg= sprintf($_LANG['smilepayibon_custom_bill_template'],$ibon,$amount,$Deadline_date,$Deadline_time): $msg =$_LANG['pay_fail'];                  
            break;
            
            case 'smilepayfami' :
                   //get fami status
                  switch ($fami){
                    case 'fami_timeout':
                     $fami =  $_LANG['smilepayfami_custom_bill_fami_error'];
                    break;
                    case 'fami_err01':
                     $fami =  $_LANG['smilepayfami_custom_bill_fami_error'];
                    break;
                    case 'fami_err02':
                     $fami =  $_LANG['smilepayfami_custom_bill_fami_error'];
                    break;
                    case 'fami_err03':
                     $fami =  $_LANG['smilepayfami_custom_bill_fami_error'];
                    break;
                    case 'fami_err04':
                     $fami =  $_LANG['smilepayfami_custom_bill_fami_error'];
                    break;
                    default:
                      $fami = $fami;                        
                  }
                  $payment = new $pay_code();            
                  ($payment->customer_bill()) ? $msg= sprintf($_LANG['smilepayfami_custom_bill_template'],$fami,$amount,$Deadline_date,$Deadline_time): $msg = $_LANG['pay_fail'];            
            break;
            }
        }
        else
        {
            $msg = $_LANG['pay_not_exist'];
        }
    }
   
}            

//var_dump($GLOBALS['ecs']->url());                      
assign_template();
$position = assign_ur_here();      
$smarty->assign('page_title', $position['title']);   // 頁面標題
$smarty->assign('ur_here',    $position['ur_here']); // 當前位置
$smarty->assign('page_title', $position['title']);   // 頁面標題
$smarty->assign('ur_here',    $position['ur_here']); // 當前位置
$smarty->assign('helps',      get_shop_help());      // 網店幫助

$smarty->assign('message',    $msg);
$smarty->assign('shop_url',   $ecs->url());

$smarty->display('respond.dwt');

 
?>